/**************************************************************************/
/*                                                                        */
/*  Thibaut Balabonski, Sylvain Conchon, Jean-Christophe Filliâtre,       */
/*  Kim Nguyen, Laurent Sartre                                            */
/*                                                                        */
/*  Informatique - MP2I/MPI - CPGE 1re et 2e années.                      */
/*  Cours et exercices corrigés. Éditions Ellipses, 2022.                 */
/*                                                                        */
/*  https://www.informatique-mpi.fr/                                      */
/*                                                                        */
/**************************************************************************/

#include "prelude.h"

/* Tri stable en fonction du caractère d'indice k */
void counting_sort(char **a, int n, int k) {
  int histo[256], dist[256];
  /* count */
  for (int c = 0; c < 256; c++) histo[c] = 0;
  for (int i = 0; i < n; i++) histo[(unsigned)a[i][k]]++;
  /* accumulate */
  dist[0] = 0;
  for (int c = 1; c < 256; c++) dist[c] = dist[c-1] + histo[c-1];
  /* distribute */
  char **aux = calloc(n, sizeof(char*));
  for (int i = 0; i < n; i++) aux[i] = a[i];
  for (int i = 0; i < n; i++) a[dist[(unsigned)aux[i][k]]++] = aux[i];
  free(aux);
}

/* Tri de chaînes par ordre lexicographique des k premiers caractères */
void string_sort(char **a, int n, int k) {
  for (int i = k - 1; i >= 0; i--) counting_sort(a, n, i);
}
